' Read any text file into a virtual array and display to user.

File$ = COMMAND$	' get command line
IF LEN(File$) = 0 THEN
  PRINT "Usage: EMSVIEW <file>"
  PRINT
  PRINT "Where <file> is the file to view."
  PRINT
  PRINT "Example: EMSVIEW c:\autoexec.bat"
  END
END IF

IF FRE(-11) < 800000 THEN
  PRINT "You do not have enough free EMS to run this program."
  END
END IF

IF LEN(DIR$(File$)) = 0 THEN	' file not found
  PRINT "The specified file, "; File$; " was not found."
  END
END IF

' accomodate up to 10,000 lines of 78 characters per line
DIM VIRTUAL vFile(1:10000) AS ASCIIZ * 78

OPEN File$ FOR INPUT AS #1
WHILE NOT EOF(1)	' read each line of file into virtual array
  LINE INPUT #1, Temp$
  INCR Counter%			' number of lines read
  IF Counter% > 10000 THEN	' maximum length exceeded
    PRINT "File longer than 10,000 lines.  Only first 10,000 lines will be displayed."
    PRINT "Press a key to continue."
    WHILE LEN(INKEY$) = 0 : WEND
    DECR Counter%	' we can't handle the last line, so decrement line count
    EXIT LOOP
  END IF
  vFile(Counter%) = Temp$	' copy line into virtual array
WEND
CLOSE #1

Page% = 1	' the page we're displaying
GOSUB UpdateScreen

DO
  WHILE NOT INSTAT : WEND	' wait for a keystroke
  Keystroke$ = INKEY$
  SELECT CASE ASC(Keystroke$)
    CASE 78, 110	' next page
      IF (Page% * 24) > Counter% THEN	' already at end of file
        SOUND 400,2
      ELSE
        INCR Page%
        GOSUB UpdateScreen
      END IF
    CASE 80, 112	' previous page
      IF Page% = 1 THEN	' already at first page
        SOUND 400,2
      ELSE
        DECR Page%
        GOSUB UpdateScreen
      END IF
    CASE 84, 116	' top
      Page% = 1
      GOSUB UpdateScreen
    CASE 66, 98		' bottom
      Page% = CEIL(Counter% / 24)
      GOSUB UpdateScreen
    CASE 88, 120	' exit
      EXIT LOOP
    CASE ELSE
      SOUND 400,2
  END SELECT
LOOP
CLS
END


PrepareScreen:	' prepare the screen
  CLS
  LOCATE 25,1
  COLOR 0,7
  PRINT "<P> Previous  <N> Next  <X> Exit  <T> Top  <B> Bottom";
  COLOR 7,0
  LOCATE 1,1
  RETURN

UpdateScreen:
  GOSUB PrepareScreen
  FOR c% = 1 TO 24
    LOCATE c%, 1
    Element% = (Page% - 1) * 24 + c%
    IF Element% > 10000 THEN EXIT FOR
    PRINT vFile(Element%);
  NEXT c%
  RETURN
